#include <stdio.h>
#include <conio.h>
#include <graphics.h>
#include <math.h>

#define SMAX 3000
#define OMAX 50


//#define LOG
//#define KUMULATIV
//#define GORBE

float s[SMAX];
float sf,sl;

void olvas();
void normal(int o);
void kumulativ(int o);
void hiszto(int hg[OMAX]);
void gorbe(int hg[OMAX]);

void main(){
	int gdriver = DETECT, gmode;
	initgraph(&gdriver, &gmode, "g:\\bc\\bgi");
	olvas();
	int c=0;
	int i=1;
	while(c!=113){ // q -113
#ifdef KUMULATIV
		kumulativ(i);
#else
		normal(i);
#endif
		c=getch();
		if(c==115)i--;
		if(c==100)i++;
		if(c==122)i=1+3.3*log(s[0]);
	}
	closegraph();
}

void olvas(){
	FILE *f=fopen("szamok.txt","rt");
	int i=0;
	float c;
	sf=0;
	while(!feof(f)){
		fscanf(f,"%f",&c);
		i++;
#ifdef LOG
		s[i]=log(c);
		if(i==1)sl=log(c);
		if(log(c)<sl)sl=log(c);
		if(log(c)>sf)sf=log(c);
#else
		s[i]=c;
		if(i==1)sl=c;
		if(c<sl)sl=c;
		if(c>sf)sf=c;
#endif

	}
	s[0]=i;
	fclose(f);
}

void normal(int o){			//	o -> osztalyok szama
	float lepes=(sf-sl)/o;
	int hg[OMAX];
	for(int i=1;i<=o;i++)hg[i]=0; hg[0]=o; //a hg tomb nullazasa
	for(i=1;i<=s[0];i++)
		hg[((s[i]-sl)/lepes)+1]++;		//hisztogramepites
#ifdef GORBE
	gorbe(hg);
#else
	hiszto(hg);
#endif
	gotoxy(1,1);printf("ostalyok szama: %d   lepes: %.2f",o,(sf-sl)/o);
}

/*void kumulativ(int o){
	float lepes=(sf-sl)/o;
	int hg[OMAX];
	for(int i=1;i<=o;i++)hg[i]=0; hg[0]=o;
	for(i=1;i<=s[0];i++){	// vegigjarja az s[]-t
		for(int k=1;sl+k*lepes<s[i];k++); //ezekbe az osztalyokba nem kerul be az s[i]
		for(;k<hg[0];k++)hg[k]++;			//ezeknel az osztalyokbal kissebb az s[i]
	}
#ifdef GORBE
	gorbe(hg);
#else
	hiszto(hg);
#endif
} */

void kumulativ(int o){
	clearviewport();
	int hg[SMAX];
	for(int i=0;i<=s[0];i++)hg[i]=0;

	for(i=1;i<=s[0];i++)
		for(int j=1;j<=s[0];j++)
			if(s[j]<=s[i])hg[i]++;

	for(i=1;i<=s[0];i++){
		double x=(640/(sf-sl))*(s[i]-sl)*(100-o)/100;
		double y=480-hg[i]/s[0]*480;
//		printf("\n%d: [%f,%d]",i,s[i],hg[i]);
		circle(x,y,3);
//		getch();
	}
}

void hiszto(int hg[OMAX]){
	clearviewport();
	int max=0; for(int i=1;i<=hg[0];i++) if(max<hg[i])max=hg[i];
	for(i=1;i<=hg[0];i++){
		int x1,x2,y1,y2;
		//x1=(i-1)*20;
		x1=(i-1)*640/hg[0];
		y1=480- ( (float)hg[i]*(float)360/(float)max );
		//x2=i*20-2;
		x2=i*640/hg[0]-2;
		y2=479;
		bar(x1,y1,x2,y2);
	}
}

void gorbe(int hg[OMAX]){
	clearviewport();
	int max=0; for(int i=1;i<=hg[0];i++) if(max<hg[i])max=hg[i];
	for(i=1;i<=hg[0]-1;i++){
		int x1,x2,y1,y2;
		x1=(i-1)*630/(hg[0]-1)+5;
		//y1=479-hg[i]*20;
		y1=480- ( (float)hg[i]*(float)360/(float)max );
		x2=i*630/(hg[0]-1)+5;
		//y2=479-hg[i+1]*20;
		y2=480- ( (float)hg[i+1]*(float)360/(float)max );
		line(x1,y1,x2,y2);
		circle(x1,y1,3);
		circle(x2,y2,3);
	}
}
